/* Copyright (C) 2011 SpringSource
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.grails.datastore.gorm.redis.bean.factory

import groovy.transform.CompileStatic
import org.grails.datastore.mapping.model.MappingContext
import org.grails.datastore.mapping.redis.RedisDatastore
import org.springframework.beans.factory.FactoryBean
import org.springframework.context.ApplicationContext
import org.springframework.context.ApplicationContextAware
import org.springframework.context.ConfigurableApplicationContext
import org.springframework.core.env.PropertyResolver

/**
 * Creates the RedisDatastore bean
 */
@CompileStatic
class RedisDatastoreFactoryBean implements FactoryBean<RedisDatastore>, ApplicationContextAware {

    PropertyResolver config
    MappingContext mappingContext
    ApplicationContext applicationContext

    RedisDatastore getObject() {
        new RedisDatastore(mappingContext, config, (ConfigurableApplicationContext)applicationContext)
    }

    Class<?> getObjectType() { RedisDatastore }

    boolean isSingleton() { true }
}
